(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
Conj[Conj[x_]]:=x;
Conj[sum]:=sum;
Conj[sumRGE]:=sumRGE;

(*------------------------------------------------ *)
(* ---------- long list of Abbreviations --------- *)
(*------------------------------------------------ *)

(* all equation numbers refer to Luo, Wang, Xiao: hep-ph/0211440v3 *)

(* bilinears in the Yukawas, eq. (19) + (34) *)
Y2Ffunc[a_,b_]:=Conj[Yijk[a,pA,pB]] Yijk[pA,b,pB];
Y2FCfunc[a_,b_]:=Yijk[a,pA,pB] Conj[Yijk[pA,b,pB]];
Y2Sfunc[a_,b_]:=1/2(Conj[Yijk[pA,pB,a]] Yijk[pB,pA,b]+Conj[Yijk[pA,pB,b]] Yijk[pB,pA,a]);



(* for 2-loop gauge couplings, eq. (31) *)
Y4F[g_]:=gc[g] Yijk[pL,pM,pN] Conj[Yijk[pM,pL,pN]] SA`CasimirRGE[pL,g]/(dimAdj[g]);

Y4F[g_,h_]:=Sum[If[Gauge[[gSUM,2]]===U[1],(SA`gCoup[gSUM,g]SA`DynL[getBlankSF[pL],gSUM]*GUTren[gSUM]),0],{gSUM,1,AnzahlGauge}] Sum[If[Gauge[[gSUM,2]]===U[1],(SA`gCoup[gSUM,h]SA`DynL[getBlankSF[pL],gSUM]*GUTren[gSUM]),0],{gSUM,1,AnzahlGauge}] Yijk[pL,pM,pN] Conj[Yijk[pM,pL,pN]];


(* for 2-loop Yukawas, eq. (24)-(27), eq. (36) *)
Lam2Sfunc[a_,b_]:=1/6 Lijkl[a,pA,pB,pC] Lijkl[b,pA,pB,pC]; 
H2abfunc[a_,b_]:=1/2 (Yijk[pA,pB,a] Conj[Yijk[pB,pC,b]] Yijk[pC,pD,pE] Conj[Yijk[pD,pA,pE]]+Conj[Yijk[pA,pB,a]] Yijk[pB,pC,b] Conj[Yijk[pC,pD,pE]] Yijk[pD,pA,pE]);
Hbar2func[a_,b_]:=1/2 (Yijk[pA,pB,a] Conj[Yijk[pB,pC,pE]] Yijk[pC,pD,b] Conj[Yijk[pD,pA,pE]]+Conj[Yijk[pA,pB,a]] Yijk[pB,pC,pE] Conj[Yijk[pC,pD,b]] Yijk[pD,pA,pE]);
Y2FSfunc[a_,b_,g_]:=1/2 SA`CasimirRGE[pA,g] (Yijk[pA,pB,a] Conj[Yijk[pB,pA,b]]+Yijk[pA,pB,b] Conj[Yijk[pB,pA,a]]);
Ha2t[a_,f1_,f2_,nr_]:=sum[vecB,1,If[Gauge[[nr,2]]===U[1],1,Gauge[[nr,2,1]]^2-1]]*(conj[tA[nr,f1,pA,vecB]]*Yijk[pA,pB,a]Conj[Yijk[pB ,pC,pD]] conj[tA[nr,pC,pE,vecB]] Yijk[pE,f2,pD]+Yijk[f1,pA,pB] tA[nr,pA,pD,vecB] Conj[Yijk[pD,pC,pB]] Yijk[pC,pE,a] tA[nr,pE,f2,vecB]);



(* for 1-loop  scalar quartic, eq. (39)  - (43) *)
Lam2func[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])*Plus@@((ExpandTermNS[Lijkl[#[[1]],#[[2]],pA,pB] Lijkl[pA,pB,#[[3]],#[[4]]]])&/@Permutations[{a,b,c,d}])/8;

Y4abcdfunc[a_,b_,c_,d_]:=YcYY[pI,pA3,a,b,c] Conj[Yijk[pA3,pI,d]]; 

Habcdfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])(Plus@@((YcYYcY4[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}]))/4;

(* LamY2func[a_,b_,c_,d_]:=Lijkl[a,b,c,pA]*YcY[pB,pB,pA,d]; *)

LamYfunc[a_,b_,c_,d_]:=ExpandTermNS[Lijkl[a,b,c,pA]YcY[pB,pB,pA,d]+Lijkl[a,pA,c,d]YcY[pB,pB,pA,b]+Lijkl[a,b,pA,d]YcY[pB,pB,pA,c]+Lijkl[pA,b,c,d]YcY[pB,pB,pA,a]];

LamSfunc[a_,b_,c_,d_]:=Sum[ (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]+SA`CasimirRGE[d,nr]),{nr,1,Length[Gauge]}]*Lijkl[a,b,c,d];
LamABCDfunc[a_,b_,c_,d_,nr_,vecB_]:=ThS[nr,a,c,vecB] ThS[nr,b,d,vecB]  sum[vecB,1,If[Gauge[[nr,2]]===U[1],1,Gauge[[nr,2,1]]^2-1]];
LamABCDsq1func[a_,b_,c_,d_,nr1_,nr2_]:=LamABCD[a,c,pA,pB,nr1,alef1] LamABCD[pA,pB,b,d,nr2,alef2];
LamABCDsq2func[a_,b_,c_,d_,nr1_,nr2_]:=LamABCD[a,pA,pB,d,nr1,alef1] LamABCD[pA,b,c,pB,nr2,alef2];
LamABCDsq1SUMfunc[a_,b_,c_,d_]:=Sum[Sum[LamABCDsq1[a,b,c,d,nr,nr2],{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
LamABCDsq2SUMfunc[a_,b_,c_,d_]:=Sum[Sum[LamABCDsq2[a,b,c,d,nr,nr2],{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
(*
Aabcdfunc[a_,b_,c_,d_]:=Plus@@((LamABCDsq1SUM[#[[1]],#[[2]],#[[3]],#[[4]]]+LamABCDsq2SUM[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4;
*)

Aabcd[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])*Plus@@((LamABCDsq1SUM[#[[1]],#[[2]],#[[3]],#[[4]]]+LamABCDsq2SUM[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4;



(* ----- for 2-loop scalar quartic, eq. (45) - (61) ----- *)
(* LamBar3func[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((Lijkl[#[[1]],#[[2]],pA,pB] Lijkl[#[[3]],pA,pC,pD] Lijkl[#[[4]],pB,pC,pD])&/@Permutations[{a,b,c,d}])/4; *)
LamBar3func[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@(((ExpandTermNS[Lijkl[#[[1]],#[[2]],pA,pB] Lijkl[#[[3]],pA,pC,pD] Lijkl[#[[4]],pB,pC,pD]])&/@(Permutations[{b,a,c,d}]//.{l1___,{a1_,b1_,c1_,d1_},l2___,{b1_,a1_,c1_,d1_},l3___}:>{l1,l2,l3,{b1,a1,c1,d1}}//.{l1___,{a1_,b1_,c1_,d1_},l2___,{a1_,b1_,d1_,c1_},l3___}:>{l1,l2,l3,{a1,b1,c1,d1}})));

LamBar2Yfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((ExpandTermNS[Y2S[pF,pG] Lijkl[#[[1]],#[[2]],pE,pF] Lijkl[#[[3]],#[[4]],pE,pG]])&/@Permutations[{a,b,c,d}])/8;

HbarLamfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((ExpandTermNS[Lijkl[#[[1]],#[[2]],pE,pF] (Y4abcd[#[[3]],pE,#[[4]],pF]+YC4abcd[#[[3]],pE,#[[4]],pF])])&/@Permutations[{a,b,c,d}])/8;

 (* Y24abcdfunc[a_,b_,c_,d_]:=Y2F[pO,pP] cYYcYY[pP,pO,a,b,c,d]; *)
Y24abcdfunc[a_,b_,c_,d_]:=Y2F[pO,pP] YcYY[pO,pR,a,b,c] Conj[Yijk[pR,pP,d]];
HYfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((Y24abcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}]);

(* Y6abcdfunc[a_,b_,c_,d_]:=Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,a]] YcYYcY[pQ,pO,pE,b,c,d]; *)
Y6abcdfunc[a_,b_,c_,d_]:=Yijk[pZ,pA3,pQ] Conj[Yijk[pA3,pR,a]] Yijk[pR,pI,pQ] cYYcY[pI,pZ,b,c,d];
YC6abcdfunc[a_,b_,c_,d_]:=Conj[Yijk[pO,pP,pE]] Yijk[pP,pQ,a] cYYcYY[pQ,pO,pE,b,c,d]; 
HbarYfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((Y6abcd[#[[1]],#[[2]],#[[3]],#[[4]]]+YC6abcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/2;

(* Y6abcd2func[a_,b_,c_,d_]:=Yijk[pO,pP,a] Conj[Yijk[pP,pQ,b]]  YcYYcY[pQ,pO,pE,c,d,pE];  *)
Y6abcd2func[a_,b_,c_,d_]:=YcY2S[pQ,pO,c,d] Yijk[pO,pA,a] Conj[Yijk[pA,pQ,b]];
H3func[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((Y6abcd2[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/2;

LamBar2SAuxfunc[a_,b_,c_,d_]:=Sum[(SA`CasimirRGE[pF,nr] Lijkl[a,b,pE,pF] Lijkl[c,d,pE,pF]),{nr,1,Length[Gauge]}];
LamBar2S[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@(LamBar2SAux[#[[1]],#[[2]],#[[3]],#[[4]]]&/@Permutations[{a,b,c,d}])/8;

LamTTfunc[a_,b_,c_,d_]:= Sum[Lijkl[a,b,pE,pF] Lijkl[c,d,pG,pH]*(ThS[nr,pE,pG,vecB]*ThS[nr,pF,pH,vecB])*sum[vecB,1,If[Gauge[[nr,2]]===U[1],1,Gauge[[nr,2,1]]^2-1]],{nr,1,Length[Gauge]}];
(*
Lam2gfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@(LamTT[#[[1]],#[[2]],#[[3]],#[[4]]]&/@Permutations[{a,b,c,d}])/8;
*)
Lam2gfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@(LamTT[#[[1]],#[[2]],#[[3]],#[[4]]]&/@(Permutations[{b,a,c,d}]//.{l1___,{a1_,b1_,c1_,d1_},l2___,{b1_,a1_,c1_,d1_},l3___}:>{l1,l2,l3,{b1,a1,c1,d1}}//.{l1___,{a1_,b1_,c1_,d1_},l2___,{a1_,b1_,d1_,c1_},l3___}:>{l1,l2,l3,{a1,b1,c1,d1}}))/2;
HSabcdfunc[a_,b_,c_,d_]:=Sum[(SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]+SA`CasimirRGE[d,nr]) Habcd[a,b,c,d],{nr,1,Length[Gauge]}];

(*
HFabcdfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Sum[Plus@@((ExpandTermNS[(SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr])(Yijk[pA,pB,#[[1]]] cYYcY[pB,pA,#[[2]],#[[3]],#[[4]]])])&/@Permutations[{a,b,c,d}]),{nr,1,Length[Gauge]}];
*)
HFabcdfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]]) Plus@@(ExpandTermNS/@((Sum[SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr],{nr,1,Length[Gauge]}]) (Yijk[pA,pB,#[[1]]] cYYcY[pB,pA,#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}]));

LamSSfunc[a_,b_,c_,d_]:=
Lijkl[a,b,c,d]*Sum[Sum[(SA`CasimirRGE[a,nr]SA`CasimirRGE[a,nr2]+SA`CasimirRGE[b,nr]SA`CasimirRGE[b,nr2]+SA`CasimirRGE[c,nr]SA`CasimirRGE[c,nr2]+SA`CasimirRGE[d,nr]SA`CasimirRGE[d,nr2]),{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];


AbarLabcdfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((ExpandTermNS[ Lijkl[#[[1]],#[[2]],pQ,pR] (LamABCDsq1SUM[#[[4]],pQ,#[[3]],pR]+ LamABCDsq2SUM[#[[4]],pQ,#[[3]],pR])])&/@Permutations[{a,b,c,d}])/2;
ALabcdfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((ExpandTermNS[ Lijkl[#[[1]],#[[2]],pQ,pR] (LamABCDsq1SUM[#[[3]],#[[4]],pQ,pR]+ LamABCDsq2SUM[#[[3]],#[[4]],pQ,pR])])&/@Permutations[{a,b,c,d}])/2;


ThThfunc[a_,b_,nr1_,nr2_]:=(ThS[nr1,a,pA,vecB1] ThS[nr2,pA,b,vecB2]);

TaTaYY1func[c_,d_,nr1_,nr2_]:=conj[tA[nr1,pP,pO,vecB1]] conj[tA[nr2,pO,pQ,vecB2]] Yijk[pQ,pR,c] Conj[Yijk[pR,pP,d]]; TaTaYY2func[c_,d_,nr1_,nr2_]:= Yijk[pO,pP,c] tA[nr1,pP,pQ,vecB1]  tA[nr2,pQ,pR,vecB2] Conj[Yijk[pR,pO,d]]; 
TaTaYY3func[c_,d_,nr1_,nr2_]:=conj[tA[nr1,pO,pP,vecB1]] Yijk[pP,pR,c] tA[nr2,pR,pQ,vecB2] Conj[Yijk[pQ,pO,d]]; 

ThThTaTaYY1func[a_,b_,c_,d_]:=
Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2])*(TaTaYY1[c,d,nr1,nr2]+TaTaYY2[c,d,nr1,nr2])sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr2,2,1]]^2-1]],{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
ThThTaTaYY2func[a_,b_,c_,d_]:=
Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2])(TaTaYY3[c,d,nr1,nr2])sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr2,2,1]]^2-1]] ,{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];


BYfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])(Plus@@(( ThThTaTaYY1[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4) ;
BYbarfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])(Plus@@(( ThThTaTaYY2[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4);


ASabcd[a_,b_,c_,d_]:=Sum[ (SA`CasimirRGE[a,nr3]+SA`CasimirRGE[b,nr3]+SA`CasimirRGE[c,nr3]+SA`CasimirRGE[d,nr3]) ,{nr3,1,Length[Gauge]}]Aabcd[a,b,c,d];

FFThThThThfunc[a_,b_,c_,d_]:=Sum[If[Gauge[[nr,2]]===U[1],0,gc[nr]^2 sum[vecA,1,Gauge[[nr,2,1]]^2-1]sum[vecB,1,Gauge[[nr,2,1]]^2-1]sum[vecC,1,Gauge[[nr,2,1]]^2-1]sum[vecD,1,Gauge[[nr,2,1]]^2-1] sum[vecE,1,Gauge[[nr,2,1]]^2-1]  FST[Gauge[[nr,2]]][vecA,vecC,vecE] FST[Gauge[[nr,2]]][vecB,vecD,vecE]  (((ThTh[a,b,nr,nr]+ThTh[b,a,nr,nr]) /.(subIndFinalX[6,7,"i"]/.subIndFinalX[6,6,"i"]))/.{vecB1:>vecA,vecB2:>vecB})((ThTh[c,d,nr,nr]
+ThTh[d,c,nr,nr])/.{vecB1:>vecC,vecB2:>vecD} )],{nr,1,Length[Gauge]}];




Agabcd[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@(( FFThThThTh[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/8;

DSLLabcdfunc[a_,b_,c_,d_]:=Sum[Sum[ SA`DynkinS[rep,nr](LamABCDsq1[a,b,c,d,nr,nr2]+LamABCDsq2[a,b,c,d,nr,nr2]),{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];


AabcdDynkinSfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((DSLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4;


(* AabcdDynkinS[a_,b_,c_,d_]:=Plus@@((DSLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4; *)

DFLLabcdfunc[a_,b_,c_,d_]:=Sum[Sum[ SA`DynkinF[rep,nr](LamABCDsq1[a,b,c,d,nr,nr2]+LamABCDsq2[a,b,c,d,nr,nr2]),{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
 AabcdDynkinFfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((DFLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4; 
(* AabcdDynkinF[a_,b_,c_,d_]:=Plus@@((DFLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4; *)

CGLLabcdfunc[a_,b_,c_,d_]:=Sum[Sum[ SA`Casimir[nr](LamABCDsq1[a,b,c,d,nr,nr2]+LamABCDsq2[a,b,c,d,nr,nr2]),{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
 AabcdC2Gfunc[a_,b_,c_,d_]:=(24/Length[Permutations[{a,b,c,d}]])Plus@@((CGLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4; 
(* AabcdC2G[a_,b_,c_,d_]:=Plus@@((CGLLabcd[#[[1]],#[[2]],#[[3]],#[[4]]])&/@Permutations[{a,b,c,d}])/4; *)


(* additional function for 2-loop quartic, cubic scalar *)
LamSC2Gfunc[a_,b_,c_,d_]:=Sum[ SA`Casimir[nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]+SA`CasimirRGE[d,nr]),{nr,1,Length[Gauge]}]*Lijkl[a,b,c,d];
LamSS2Ffunc[a_,b_,c_,d_]:=Sum[ SA`DynkinF[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]+SA`CasimirRGE[d,nr]),{nr,1,Length[Gauge]}]*Lijkl[a,b,c,d];
LamSS2Sfunc[a_,b_,c_,d_]:=Sum[SA`DynkinS[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]+SA`CasimirRGE[d,nr]),{nr,1,Length[Gauge]}]*Lijkl[a,b,c,d];

LamSC2Gfunc[a_,b_,c_]:=Sum[SA`Casimir[nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]),{nr,1,Length[Gauge]}]*Aijk[a,b,c];
LamSS2Ffunc[a_,b_,c_]:=Sum[ SA`DynkinF[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]),{nr,1,Length[Gauge]}]*Aijk[a,b,c];
LamSS2Sfunc[a_,b_,c_]:=Sum[ SA`DynkinS[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]),{nr,1,Length[Gauge]}]*Aijk[a,b,c];
LamSC2Gfunc[a_,b_]:=Sum[ SA`Casimir[nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]),{nr,1,Length[Gauge]}]*Bij[a,b];
LamSS2F[a_,b_]:=Sum[ SA`DynkinF[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]),{nr,1,Length[Gauge]}]*Bij[a,b];
LamSS2S[a_,b_]:=Sum[ SA`DynkinS[rep,nr] (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]),{nr,1,Length[Gauge]}]*Bij[a,b];



(* for 1-loop  scalar cubic, eq. (65)  - (68) *)


Lam2func[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])1/2 Plus@@((Lijkl[#[[1]],#[[2]],pA,pB] Aijk[pA,pB,#[[3]]])&/@Permutations[{a,b,c}]);
Habcfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])/2Plus@@((Muij[pO,pP] Conj[Yijk[pP,pQ,#[[1]]]] Yijk[pQ,pR,#[[2]]] Conj[Yijk[pR,pO,#[[3]]]]+Yijk[pO,pP,#[[1]]] Conj[Muij[pP,pQ]] Yijk[pQ,pR,#[[2]]] Conj[Yijk[pR,pO,#[[3]]]])&/@Permutations[{a,b,c}]);
LamYfunc[a_,b_,c_]:=(Y2S[a,pC] Aijk[pC,b,c]+Y2S[b,pC] Aijk[a,pC,c]+Y2S[c,pC] Aijk[a,b,pC] );
(* LamYfunc[a_,b_,c_]:=1/2(Conj[Yijk[pA,pB,a]] Yijk[pB,pA,pC] Aijk[pC,b,c]+Conj[Yijk[pA,pB,b]] Yijk[pB,pA,pC] Aijk[a,pC,c]+Conj[Yijk[pA,pB,c]] Yijk[pB,pA,pC] Aijk[a,b,pC] +
Conj[Yijk[pA,pB,a]] Yijk[pB,pA,pC] Conj[Aijk[pC,b,c]]+Conj[Yijk[pA,pB,b]] Yijk[pB,pA,pC] Conj[Aijk[a,pC,c]]+Conj[Yijk[pA,pB,c]] Yijk[pB,pA,pC] Conj[Aijk[a,b,pC]]); *)
 LamSfunc[a_,b_,c_]:=Sum[ (SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]) Aijk[a,b,c],{nr,1,Length[Gauge]}];


(* for 2-loop scalar cubic, eq. (70) - (85) *)
LamBar3func[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((Lijkl[#[[1]],#[[2]],pA,pB] Lijkl[#[[3]],pA,pC,pD] Aijk[pB,pC,pD]+Lijkl[#[[1]],pA,pB,pC] Lijkl[#[[2]],pD,pB,pC] Aijk[#[[3]],pA,pD])&/@Permutations[{a,b,c}])/2
LamBar2Yfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((Y2S[pF,pG] Lijkl[#[[1]],#[[2]],pE,pF] Aijk[#[[3]],pE,pG])&/@Permutations[{a,b,c}])/2;

HbarLamMAuxfunc[a_,b_,c_]:=Lijkl[a,b,pE,pF] (Yijk[pO,pP,c] Conj[Yijk[pP,pQ,pE]] Muij[pQ,pR] Conj[Yijk[pR,pO,pF]]+Muij[pO,pP] Conj[Yijk[pP,pQ,pE]]Yijk[pQ,pR,c] Conj[Yijk[pR,pO,pF]]+Conj[Yijk[pO,pP,c]] Yijk[pP,pQ,pE] Conj[Muij[pQ,pR]] Yijk[pR,pO,pF]+Conj[Muij[pO,pP]] Yijk[pP,pQ,pE] Conj[Yijk[pQ,pR,c]] Yijk[pR,pO,pF]);
HbarLamMfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((HbarLamMAux[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}])/8;

HbarHAuxfunc[a_,b_,c_]:=Aijk[a,pE,pF] (Yijk[pO,pP,b] Conj[Yijk[pP,pQ,pE]]Yijk[pQ,pR,c]Conj[Yijk[pR,pO,pF]]+
Conj[Yijk[pO,pP,b]] Yijk[pP,pQ,pE]Conj[Yijk[pQ,pR,c]]Yijk[pR,pO,pF]);
HbarHfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((HbarHAux[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}])/4;

HYAuxfunc[a_,b_,c_]:=Y2F[pO,pP] (Conj[Muij[pP,pQ]] Yijk[pQ,pR,a] Conj[Yijk[pR,pS,b]] Yijk[pS,pO,c]+Conj[Yijk[pP,pQ,a]] Muij[pQ,pR] Conj[Yijk[pR,pS,b]] Yijk[pS,pO,c]+Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,b] Conj[Muij[pR,pS]] Yijk[pS,pO,c]+Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,b] Conj[Yijk[pR,pS,c]] Muij[pS,pO]);
HYfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((HYAux[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}]);

HYbarAuxfunc[a_,b_,c_]:=Yijk[pO,pP,pE] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,a]] Yijk[pS,pT,b] Conj[Yijk[pT,pO,c]]+
Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE] Conj[Muij[pR,pS]] Yijk[pS,pT,b] Conj[Yijk[pT,pO,c]]+
Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,b]] Muij[pS,pT] Conj[Yijk[pT,pO,c]] +
Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,b]] Yijk[pS,pT,c] Conj[Muij[pT,pO]] ;
HYbarfunc[a_,b_,c_]:=(6 /Length[Permutations[{a,b,c}]])Plus@@((HYbarAux[#[[1]],#[[2]],#[[3]]]+Conj[HYbarAux[#[[1]],#[[2]],#[[3]]]])&/@Permutations[{a,b,c}])/2;

H3Auxfunc[a_,b_,c_]:=Muij[pO,pP] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,b]] Yijk[pS,pT,c] Conj[Yijk[pT,pO,pE]]+
Yijk[pO,pP,a] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,b]] Yijk[pS,pT,c] Conj[Yijk[pT,pO,pE]]+
Yijk[pO,pP,a] Conj[Yijk[pP,pQ,b]] Yijk[pQ,pR,pE] Conj[Muij[pR,pS]] Yijk[pS,pT,c] Conj[Yijk[pT,pO,pE]]+
Yijk[pO,pP,a] Conj[Yijk[pP,pQ,b]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,c]]Muij[pS,pT] Conj[Yijk[pT,pO,pE]];
H3func[a_,b_,c_]:=(6 /Length[Permutations[{a,b,c}]])Plus@@((H3Aux[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}])/2;



LamBar2SAuxfunc[a_,b_,c_]:=Sum[(SA`CasimirRGE[pF,nr] Aijk[a,pE,pF] Lijkl[b,c,pE,pF]),{nr,1,Length[Gauge]}];
LamBar2S[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@(LamBar2SAux[#[[1]],#[[2]],#[[3]]]&/@Permutations[{a,b,c}])/2;


LamTTfunc[a_,b_,c_]:= Sum[Aijk[a,pE,pF] Lijkl[b,c,pG,pH]*(ThS[nr,pE,pG,vecB]*ThS[nr,pF,pH,vecB])*sum[vecB,1,If[Gauge[[nr,2]]===U[1],1,Gauge[[nr,2,1]]^2-1]],{nr,1,Length[Gauge]}];
Lam2gfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@(LamTT[#[[1]],#[[2]],#[[3]]]&/@Permutations[{a,b,c}])/2;


HSabcfunc[a_,b_,c_]:=Sum[(SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr]+SA`CasimirRGE[c,nr]) Habc[a,b,c],{nr,1,Length[Gauge]}];
HFabcAuxfunc[a_,b_,c_]:=Sum[((SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr])(Muij[pA,pB] Conj[Yijk[pB,pC,a]] Yijk[pC,pD,b] Conj[Yijk[pD,pA,c]])+
(SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr])(Yijk[pA,pB,a] Conj[Muij[pB,pC]] Yijk[pC,pD,b] Conj[Yijk[pD,pA,c]])+
(SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr])(Yijk[pA,pB,a] Conj[Yijk[pB,pC,b]] Muij[pC,pD] Conj[Yijk[pD,pA,c]])+
(SA`CasimirRGE[pA,nr]+SA`CasimirRGE[pB,nr])(Yijk[pA,pB,a] Conj[Yijk[pB,pC,b]] Yijk[pC,pD,c] Conj[Muij[pD,pA]])),{nr,1,Length[Gauge]}]
HFabcfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@((HFabcAux[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}]);

LamSSfunc[a_,b_,c_]:=
Aijk[a,b,c]*Sum[Sum[(SA`CasimirRGE[a,nr]SA`CasimirRGE[a,nr2]+SA`CasimirRGE[b,nr]SA`CasimirRGE[b,nr2]+SA`CasimirRGE[c,nr]SA`CasimirRGE[c,nr2]),{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];


AbarLabcfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@(( Aijk[#[[1]],pQ,pR] (LamABCDsq1SUM[pQ,#[[3]],#[[2]],pR]+ LamABCDsq2SUM[pQ,#[[3]],#[[2]],pR]))&/@Permutations[{a,b,c}]);
ALabcfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])Plus@@(( Aijk[#[[1]],pQ,pR] (LamABCDsq1SUM[#[[2]],#[[3]],pQ,pR]+ LamABCDsq2SUM[#[[2]],#[[3]],pQ,pR]))&/@Permutations[{a,b,c}]);


TaTaYM1func[c_,nr1_,nr2_]:=conj[tA[nr1,pO,pP,vecB1]] conj[tA[nr2,pP,pQ,vecB2]] Muij[pQ,pR] Conj[Yijk[pR,pO,c]];
TaTaYM2func[c_,nr1_,nr2_]:=Muij[pR,pO]tA[nr1,pO,pP,vecB1] tA[nr2,pP,pQ,vecB2] Conj[Yijk[pQ,pR,c]];
TaTaYM3func[c_,nr1_,nr2_]:=conj[tA[nr1,pO,pP,vecB1]] conj[tA[nr2,pP,pQ,vecB2]] Yijk[pQ,pR,c] Conj[Muij[pR,pO]];
TaTaYM4func[c_,nr1_,nr2_]:=Yijk[pR,pO,c]tA[nr1,pO,pP,vecB1] tA[nr2,pP,pQ,vecB2] Conj[Muij[pQ,pR]];

TaTaYM5func[c_,nr1_,nr2_]:=conj[tA[nr1,pO,pP,vecB1]]  Muij[pP,pQ]tA[nr2,pQ,pR,vecB2] Conj[Yijk[pR,pO,c] ];
TaTaYM6func[c_,nr1_,nr2_]:=conj[tA[nr1,pO,pP,vecB1]] Yijk[pP,pQ,c]tA[nr2,pQ,pR,vecB2] Conj[Muij[pR,pO] ];

ThThTaTaYM1func[a_,b_,c_]:=
Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2])*(TaTaYM1[c,nr1,nr2]+TaTaYM2[c,nr1,nr2]+TaTaYM3[c,nr1,nr2]+TaTaYM4[c,nr1,nr2])sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr2,2,1]]^2-1]],{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
ThThTaTaYM2func[a_,b_,c_]:=
Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2])(TaTaYM5[c,nr1,nr2]+TaTaYM6[c,nr1,nr2])sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr2,2,1]]^2-1]] ,{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];


BYfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])(Plus@@(( ThThTaTaYM1[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}])/4) ;
BYbarfunc[a_,b_,c_]:=(6/Length[Permutations[{a,b,c}]])(Plus@@(( ThThTaTaYM2[#[[1]],#[[2]],#[[3]]])&/@Permutations[{a,b,c}])/4);



(* for 1-loop scalar mass, eq. (87) -  (89) *)
Habfunc[a_,b_]:=((Yijk[pA,pB,a]Conj[Yijk[pB,pC,b]]+Yijk[pA,pB,b]Conj[Yijk[pB,pC,a]])Muij[pC,pD]Conj[Muij[pD,pA]]+(Conj[Yijk[pA,pB,a]]Yijk[pB,pC,b]+Conj[Yijk[pA,pB,b]]Yijk[pB,pC,a])Conj[Muij[pC,pD]]Muij[pD,pA]+Yijk[pA,pB,a] Conj[Muij[pB,pC]]Yijk[pC,pD,b] Conj[Muij[pD,pA]]+Muij[pA,pB]Conj[Yijk[pB,pC,a]]Muij[pC,pD] Conj[Yijk[pD,pA,b]] ); 



LamSfunc[a_,b_]:=Sum[ (SA`CasimirRGE[a,nr]Bij[a,b]+SA`CasimirRGE[b,nr]Bij[a,b]),{nr,1,Length[Gauge]}];
(* LamYfunc[a_,b_]:=1/2(Yijk[pA,pB,a] Conj[Yijk[pB,pA,pC]]+Conj[Yijk[pA,pB,a]]Yijk[pB,pA,pC])Bij[pC,b]+1/2(Yijk[pA,pB,b] Conj[Yijk[pB,pA,pC]]+Conj[Yijk[pA,pB,b]] Yijk[pB,pA,pC])Bij[pC,a]; *)
(* LamYfunc[a_,b_]:=(Yijk[pA,pB,a] Conj[Yijk[pB,pA,pC]]Bij[pC,b]+Yijk[pA,pB,b] Conj[Yijk[pB,pA,pC]]Bij[pC,a]); *)

(* WTF???? THIS ISNT RIGHT! Corrected MDG 2023-5-12, thanks Pedro Ferreira *)
(*LamYfunc[a_,b_]:=Y2S[a,a]Bij[a,b]+Y2S[b,b] Bij[a,b];*)
LamYfunc[a_,b_]:=(Y2S[a,pC]Bij[pC,b]+ Y2S[b,pC]Bij[pC,a]);



(* LamYfunc[a_,b_]:=(Y2S[a,pC]Bij[pC,b]+ Y2S[b,pC]Bij[pC,a]); *)


(* for 2-loop scalar mass, eq. (91) -  (105) *)
LamBar3func[a_,b_]:=Lijkl[a,b,pE,pF] Aijk[pE,pG,pL] Aijk[pF,pG,pL] +2 Bij[pE,pF] Lijkl[a,pE,pG,pL] Lijkl[b,pF,pG,pL] + 2 Aijk[a,pE,pF] Aijk[pF,pG,pL] Lijkl[b,pE,pG,pL] + 2 Aijk[b,pE,pF] Aijk[pF,pG,pL] Lijkl[a,pE,pG,pL];
LamBar2Yfunc[a_,b_]:=Y2S[pF,pG](Bij[pE,pG] Lijkl[a,b,pE,pF]+ Aijk[a,pE,pF] Aijk[b,pE,pG]);

HbarLamfunc[a_,b_]:=1/2 Lijkl[a,b,pE,pF] (Muij[pO,pX]Conj[Yijk[pX,pQ,pE]] Muij[pQ,pY] Conj[Yijk[pY,pO,pF]]+Conj[Muij[pO,pX]]Yijk[pX,pQ,pE] Conj[Muij[pQ,pY]] Yijk[pY,pO,pF])+(* Bij[pE,pF](YcYYcY4[a,pE,b,pF]+cYYcYY4[a,pE,b,pF])+ *)
Bij[pE,pF](Yijk[pO,pX,b] Conj[Yijk[pX,pQ,pE]] Yijk[pQ,pY,a] Conj[Yijk[pY,pO,pF]]+Conj[Yijk[pO,pX,b]]Yijk[pX,pQ,pE] Conj[Yijk[pQ,pY,a]] Yijk[pY,pO,pF])+  Aijk[a,pE,pF]  (Yijk[pO,pX,b] Conj[Yijk[pX,pQ,pE]] Muij[pQ,pY] Conj[Yijk[pY,pO,pF]]+Conj[Yijk[pO,pX,b]] Yijk[pX,pQ,pE] Conj[Muij[pQ,pY]] Yijk[pY,pO,pF])+Aijk[b,pE,pF](Yijk[pO,pX,a] Conj[Yijk[pX,pQ,pE]] Muij[pQ,pY] Conj[Yijk[pY,pO,pF]]+Conj[Yijk[pO,pX,a]] Yijk[pX,pQ,pE] Conj[Muij[pQ,pY]] Yijk[pY,pO,pF]);


(*
HYfunc[a_,b_]:=(Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Muij[pP,pQ]]Muij[pQ,pR]+Conj[Muij[pO,pQ]]Muij[pQ,pP]Conj[Yijk[pP,pX,pY]] Yijk[pX,pR,pY])(Conj[Yijk[pR,pA1,a]] Yijk[pA1,pO,b]+Conj[Yijk[pR,pA1,b]] Yijk[pA1,pO,a])+
2( Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Yijk[pP,pA1,a]] Muij[pA1,pR] (Conj[Yijk[pR,pX,b]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,b])+
Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Muij[pP,pA1]] Yijk[pA1,pR,a](Conj[Yijk[pR,pX,b]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,b]));
*)
HYfunc[a_,b_]:=(Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Muij[pP,pQ]]Muij[pQ,pR]+Conj[Muij[pO,pQ]]Muij[pQ,pP]Conj[Yijk[pP,pX,pY]] Yijk[pX,pR,pY])(Conj[Yijk[pR,pA1,a]] Yijk[pA1,pO,b]+Conj[Yijk[pR,pA1,b]] Yijk[pA1,pO,a])+
( Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Yijk[pP,pA1,a]] Muij[pA1,pR] (Conj[Yijk[pR,pX,b]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,b])+
Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Muij[pP,pA1]] Yijk[pA1,pR,a](Conj[Yijk[pR,pX,b]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,b]))+
( Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Yijk[pP,pA1,b]] Muij[pA1,pR] (Conj[Yijk[pR,pX,a]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,a])+
Conj[Yijk[pO,pA,pB]] Yijk[pA,pP,pB] Conj[Muij[pP,pA1]] Yijk[pA1,pR,b](Conj[Yijk[pR,pX,a]]Muij[pX,pO]+Conj[Muij[pR,pX]] Yijk[pX,pO,a]));

HYbarfunc[a_,b_]:=(Yijk[pO,pP,pE] Conj[Yijk[pP,pR,a]] Yijk[pR,pS,pE] Conj[Yijk[pS,pQ,b]]+Yijk[pO,pP,pE] Conj[Yijk[pP,pR,b]] Yijk[pR,pS,pE] Conj[Yijk[pS,pQ,a]])Muij[pQ,pX]Conj[Muij[pX,pO]]+Yijk[pO,pP,pE] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE] Conj[Muij[pR,pS]](Yijk[pS,pT,a] Conj[Yijk[pT,pO,b]]+Yijk[pS,pT,b] Conj[Yijk[pT,pO,a]])+Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE] Conj[Muij[pR,pS]](Yijk[pS,pT,b] Conj[Muij[pT,pO]]+Muij[pS,pT] Conj[Yijk[pT,pO,b]])+
Yijk[pO,pP,pE] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,a]](Yijk[pS,pT,b] Conj[Muij[pT,pO]]+Muij[pS,pT] Conj[Yijk[pT,pO,b]])+
Yijk[pO,pP,pE] Conj[Yijk[pP,pQ,b]] Yijk[pQ,pR,pE] Conj[Muij[pR,pS]](Yijk[pS,pT,a] Conj[Muij[pT,pO]]+Muij[pS,pT] Conj[Yijk[pT,pO,a]])+
Yijk[pO,pP,pE] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE] Conj[Yijk[pR,pS,b]](Yijk[pS,pT,a] Conj[Muij[pT,pO]]+Muij[pS,pT] Conj[Yijk[pT,pO,a]]); 


H3abfunc[a_,b_]:=(Yijk[pO,pP,a] Conj[Yijk[pP,pQ,b]])Yijk[pQ,pR,pE] Conj[Muij[pR,pS]] Muij[pS,pT] Conj[Yijk[pT,pO,pE]]+
Muij[pT,pO] Conj[Muij[pO,pP]] Yijk[pP,pQ,pE](Conj[Yijk[pQ,pR,a]] Yijk[pR,pS,b])Conj[Yijk[pS,pT,pE]]+
Yijk[pO,pP,a] Conj[Muij[pP,pQ]] Yijk[pQ,pR,pE](Conj[Yijk[pR,pS,b]]Muij[pS,pT]+Conj[Muij[pR,pS]] Yijk[pS,pT,b])Conj[Yijk[pT,pO,pE]]+
Muij[pO,pP] Conj[Yijk[pP,pQ,a]] Yijk[pQ,pR,pE](Conj[Yijk[pR,pS,b]]Muij[pS,pT]+Conj[Muij[pR,pS]] Yijk[pS,pT,b])Conj[Yijk[pT,pO,pE]];


LamBar2Sfunc[a_,b_]:=Sum[(SA`CasimirRGE[pF,nr] Lijkl[a,b,pE,pF] Bij[pE,pF] + SA`CasimirRGE[pF,nr] Aijk[a,pE,pF] Aijk[b,pE,pF]),{nr,1,Length[Gauge]}];
Lam2gfunc[a_,b_]:=Sum[(Lijkl[a,b,pE,pF] Bij[pG,pL]+ Aijk[a,pE,pF] Aijk[b,pG,pL]) ThS[nr,pE,pG,vec1B] ThS[nr,pF,pL,vec1B]sum[vec1B,1,If[Gauge[[nr,2]]===U[1],1,Gauge[[nr,2,1]]^2-1]],{nr,1,Length[Gauge]}];
HSabfunc[a_,b_]:=Sum[(SA`CasimirRGE[a,nr]+SA`CasimirRGE[b,nr])Hab[a,b],{nr,1,Length[Gauge]}];

HFabfunc[a_,b_]:=2 Sum[ ((SA`CasimirRGE[pO,nr]+SA`CasimirRGE[pP,nr]) Yijk[pO,pP,a] Conj[Yijk[pP,pQ,b]] Muij[pQ,pR] Conj[Muij[pR,pO]]+ (SA`CasimirRGE[pO,nr]+SA`CasimirRGE[pP,nr])Muij[pO,pP] Conj[Muij[pP,pR]](Yijk[pR,pQ,a] Conj[Yijk[pQ,pO,b]])+(SA`CasimirRGE[pO,nr]+SA`CasimirRGE[pP,nr])Yijk[pO,pP,a] Conj[Muij[pP,pQ]](Yijk[pQ,pR,b]Conj[Muij[pR,pO]]+Muij[pQ,pR] Conj[Yijk[pR,pO,b]])+
(SA`CasimirRGE[pO,nr]+SA`CasimirRGE[pP,nr])Muij[pO,pP]Conj[Yijk[pP,pQ,a]](Yijk[pQ,pR,b] Conj[Muij[pR,pO]]+Muij[pQ,pR] Conj[Yijk[pR,pO,b]])),{nr,1,Length[Gauge]}];

LamSSfunc[a_,b_]:=Sum[Sum[(SA`CasimirRGE[a,nr]*SA`CasimirRGE[a,nr2]+SA`CasimirRGE[b,nr]*SA`CasimirRGE[b,nr2])Bij[a,b],{nr,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];

AlamBarfunc[a_,b_]:= 2Bij[pR,pQ](LamABCDsq1SUM[b,pQ,a,pR]+ LamABCDsq2SUM[b,pQ,a,pR]);
Alamfunc[a_,b_]:=2Bij[pR,pQ](LamABCDsq1SUM[a,b,pR,pQ]+ LamABCDsq2SUM[a,b,pR,pQ]);



BYfunc[a_,b_]:=Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2]) (conj[tA[nr1,pO,pP,vecB1]] conj[tA[nr2,pP,pQ,vecB2]] Muij[pQ,pR] Conj[Muij[pR,pO]] + Muij[pO,pP] tA[nr1,pP,pQ,vecB1] tA[nr2,pQ,pR,vecB2] Conj[Muij[pR,pO]]  ) sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]],{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];
BYbarfunc[a_,b_]:=Sum[Sum[(ThTh[a,b,nr1,nr2]+ThTh[b,a,nr1,nr2] ) (conj[tA[nr1,pO,pP,vecB1]] Muij[pP,pQ] tA[nr2,pQ,pR,vecB2] Conj[Muij[pR,pO]]) sum[vecB1,1,If[Gauge[[nr1,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]]sum[vecB2,1,If[Gauge[[nr2,2]]===U[1],1,Gauge[[nr1,2,1]]^2-1]],{nr1,1,Length[Gauge]}],{nr2,1,Length[Gauge]}];

(* some more auxiliary functions *)

McMfunc[f1_,f2_]:=Muij[f1,pA1] Conj[Muij[pA1,f2]];
cMMfunc[f1_,f2_]:=Conj[Muij[f1,pA1]] Muij[pA1,f2];
YcMfunc[f1_,f2_,s1_]:=Yijk[f1,pA1,s1] Conj[Muij[pA1,f2]];
cYMfunc[f1_,f2_,s1_]:=Conj[Yijk[f1,pA1,s1]] Muij[pA1,f2];
McYfunc[f1_,f2_,s1_]:=Muij[f1,pA1] Conj[Yijk[pA1,f2,s1]];
cMYfunc[f1_,f2_,s1_]:=Conj[Muij[f1,pA1]] Yijk[pA1,f2,s1];
YcYfunc[f1_,f2_,s1_,s2_]:=1/2(Yijk[f1,pA1,s1] Conj[Yijk[pA1,f2,s2]]+Conj[Yijk[f1,pA1,s1]] Yijk[pA1,f2,s2]);
YcY2Sfunc[f1_,f2_,s1_,s2_]:=Yijk[f1,pA1,pA2] Conj[Yijk[pA1,pA3,s1]] Yijk[pA3,pI,s2]Conj[Yijk[pI,f2,pA2]]  ;

(* YcYYfunc[f1_,f2_,s1_,s2_,s3_]:=YcY[f1,pA2,s1,s2] Yijk[pA2,f2,s3]; *)
YcYYfunc[f1_,f2_,s1_,s2_,s3_]:=Yijk[f1,pA1,s1] Conj[Yijk[pA1,pA2,s2]] Yijk[pA2,f2,s3];
YcYYcYfunc[f1_,f2_,s1_,s2_,s3_,s4_]:=YcYY[f1,pA3,s1,s2,s3] Conj[Yijk[pA3,f2,s4]];
YcYYcY4func[s1_,s2_,s3_,s4_]:=YcYY[pQ,pA3,s1,s2,s3] Conj[Yijk[pA3,pQ,s4]];




(* ::Input::Initialization:: *)
SA`sub4Scalar={};


Init4ScalarFunctions[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init4ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 4 external scalars and optionally a gauge structure. All possible field combinations of external scalars are considered.";
SA`Doc`Input={"list1in"->"List of functions with four external scalars","list1inNE"->"List of functions with four external scalars (where the results should not be expanded","list2in"->"List of functions with four external scalars and a gauge index","list3in"->"List of functions with four external scalars and a gauge index as well as an external vector boson","list4in"->"List of functions with four external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
For[i1=1,i1<=Length[PART[S]],
For[i2=1,i2<=Length[PART[S]],
For[i3=1,i3<=Length[PART[S]],
For[i4=1,i4<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4]]=CalcDelta[(ExpandTermNS[list1b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],getFullNS[PART[S][[i4]]]/. subGC[4] ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4]]=(list1NE[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],getFullNS[PART[S][[i4]]]/. subGC[4]]);
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4],k]=CalcDelta[(ExpandTermNS[list2b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],getFullNS[PART[S][[i4]]]/. subGC[4],k ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[il=1,il<=Length[list4b],
list4b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4],k, vecB_]=CalcDelta[(ExpandTermNS[list4b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],getFullNS[PART[S][[i4]]]/. subGC[4],k,vecB]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4],k, k2]=CalcDelta[(ExpandTermNS[list3b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],getFullNS[PART[S][[i4]]]/. subGC[4],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
k2++;];
k++;];
i4++;];
i3++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
]; 



Init4ScalarFunctionsFinal[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,listP},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init4ScalarFunctionsFinal\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 4 external scalars and optionally a gauge structure. Only field combinations are included which give valid tree-level couplings.";
SA`Doc`Input={"list1in"->"List of functions with four external scalars","list1inNE"->"List of functions with four external scalars (where the results should not be expanded","list2in"->"List of functions with four external scalars and a gauge index","list3in"->"List of functions with four external scalars and a gauge index as well as an external vector boson","list4in"->"List of functions with four external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];

(* listP=Intersection[Table[getBlank/@lA4oneNewFlat[[i,1]],{i,1,Length[lA4oneNewFlat]}]]; *)
listP=Intersection[getBlank/@lA4oneNewFlat];

For[i1=1,i1<=Length[listP],For[il=1,il<=Length[list1b],list1b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],getFullNS[listP[[i1,4]]]/.subGCRule[4]]=(list1b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],getFullNS[listP[[i1,4]]]/.subGC[4]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
For[il=1,il<=Length[list1NE],list1NE[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],getFullNS[listP[[i1,4]]]/.subGCRule[4]]=(list1NE[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],getFullNS[listP[[i1,4]]]/.subGC[4]]);
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],getFullNS[listP[[i1,4]]]/.subGCRule[4],k]=(ExpandTermNS[list2b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],getFullNS[listP[[i1,4]]]/.subGC[4],k]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
For[il=1,il<=Length[list4b],list4b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],getFullNS[listP[[i1,4]]]/.subGCRule[4],k,vecB_]=(ExpandTermNS[list4b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],getFullNS[listP[[i1,4]]]/.subGC[4],k,vecB]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
For[k2=1,k2<=Length[Gauge],For[il=1,il<=Length[list3b],list3b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],getFullNS[listP[[i1,4]]]/.subGCRule[4],k,k2]=(ExpandTermNS[list3b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],getFullNS[listP[[i1,4]]]/.subGC[4],k,k2]](*//.sum[a_,b_,c_] d_\[RuleDelayed]Sum[d,{a,b,c}]*)/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
k2++;];
k++;];
i1++;];

SA`Doc`EndEntry[];
]; 

(*
For[i1=1,i1\[LessEqual]Length[per],
For[i2=i1,i2\[LessEqual]Length[per],
LamTT[getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i2,1]]]/. subGCRule[3],getFullNS[per[[i2,2]]]/. subGCRule[4]]=(ExpandTermNS[LamTTfunc[getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i2,1]]]/. subGC[3],getFullNS[per[[i2,2]]]/. subGC[4] ]]/. {Yijk[a__]\[Rule]0,Aijk[a__]\[Rule]0, Muij[a__]\[Rule]0, Bij[a__]\[Rule]0, LSi\[Rule]0 /. Li\[Rule]0});
i2++;];
i1++;];
*)
Init4ScalarFunctionsSymm[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,per},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init4ScalarFunctionsSymm\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 4 external scalars and optionally a gauge structure. Only specific field combinations are considered.";
SA`Doc`Input={"list1in"->"List of functions with four external scalars","list1inNE"->"List of functions with four external scalars (where the results should not be expanded","list2in"->"List of functions with four external scalars and a gauge index","list3in"->"List of functions with four external scalars and a gauge index as well as an external vector boson","list4in"->"List of functions with four external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
(* per=Intersection[Sort/@Permutations[Join[PART[S],PART[S]],{2}]]; *)
per=Map[getFullNS[#]&,Intersection[Sort/@getBlank/@Permutations[Join[PART[S],PART[S]],{2}]],{2}];
For[i1=1,i1<=Length[per],
For[i2=i1,i2<=Length[per],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i2,1]]]/. subGCRule[3],getFullNS[per[[i2,2]]]/. subGCRule[4]]=CalcDelta[(ExpandTermNS[list1b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i2,1]]]/. subGC[3],getFullNS[per[[i2,2]]]/. subGC[4] ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
]; 

Init4ScalarFunctionsPermutated[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,per},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init4ScalarFunctionsPermutated\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 4 external scalars and optionally a gauge structure. All permuations of field combinations are included which give valid tree-level couplings.";
SA`Doc`Input={"list1in"->"List of functions with four external scalars","list1inNE"->"List of functions with four external scalars (where the results should not be expanded","list2in"->"List of functions with four external scalars and a gauge index","list3in"->"List of functions with four external scalars and a gauge index as well as an external vector boson","list4in"->"List of functions with four external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
(* per=Intersection[Flatten[Permutations/@Intersection[Sort/@Table[getBlank[lA4oneNewFlat[[i,1]]],{i,1,Length[lA4oneNewFlat]}]],1]];  *)
per=Intersection[Flatten[Permutations/@Intersection[Sort/@getBlank/@lA4oneNewFlat],1]]; 


For[i1=1,i1<=Length[per],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4]]=CalcDelta[(ExpandTermNS[list1b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4] ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4]]=(list1NE[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4] ]);
il++;];

For[k=1,k<=Length[Gauge],
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4],k, k2]=CalcDelta[(ExpandTermNS[list3b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
k2++;];
k++;];

i1++;];

SA`Doc`EndEntry[];
];
Init4ScalarFunctionsPermutatedAll[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,per},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init4ScalarFunctionsPermutatedAll\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 4 external scalars and optionally a gauge structure. All permuations of field combinations are included which give valid tree-level couplings.";
SA`Doc`Input={"list1in"->"List of functions with four external scalars","list1inNE"->"List of functions with four external scalars (where the results should not be expanded","list2in"->"List of functions with four external scalars and a gauge index","list3in"->"List of functions with four external scalars and a gauge index as well as an external vector boson","list4in"->"List of functions with four external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
(* per=Intersection[Flatten[Permutations/@Intersection[Sort/@Table[getBlank[lA4oneNewFlat[[i,1]]],{i,1,Length[lA4oneNewFlat]}]],1]]; *)
per=Intersection[Flatten[Permutations/@Intersection[Sort/@Table[getBlank[lA4[[i,1]]],{i,1,Length[lA4]}]],1]];
For[i1=1,i1<=Length[per],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4]]=CalcDelta[(ExpandTermNS[list1b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4] ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4]]=(list1NE[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4] ]);
il++;];

For[k=1,k<=Length[Gauge],
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],getFullNS[per[[i1,4]]]/. subGCRule[4],k, k2]=CalcDelta[(ExpandTermNS[list3b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],getFullNS[per[[i1,4]]]/. subGC[4],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
k2++;];
k++;];

i1++;];

SA`Doc`EndEntry[];
];



Init3ScalarFunctions[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init3ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 3 external scalars and optionally a gauge structure. All possible field combinations are considered.";
SA`Doc`Input={"list1in"->"List of functions with three external scalars","list1inNE"->"List of functions with three external scalars (where the results should not be expanded","list2in"->"List of functions with three external scalars and a gauge index","list4in"->"List of functions with three external scalars and a gauge index as well as an external vector boson","list3in"->"List of functions with three external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
For[i1=1,i1<=Length[PART[S]],
For[i2=1,i2<=Length[PART[S]],
For[i3=1,i3<=Length[PART[S]],
If[(Aijk[getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3]]/. Aijk[a__]->0)===FALSE,
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3]]=0;
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3]]=0;
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k]=0;
il++;];
For[il=1,il<=Length[list4b],
list4b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k, vecB_]=0;
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k, k2]=0;
il++;];
k2++;];
k++;];,
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3]]=ExpandTermNS[list1b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3]]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3]]=list1NE[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3]];
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k]=ExpandTermNS[list2b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],k ]](* //. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[il=1,il<=Length[list4b],
list4b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k, vecB_]=ExpandTermNS[list4b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],k,vecB]](*//.  sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],k, k2]=ExpandTermNS[list3b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],getFullNS[PART[S][[i3]]]/. subGC[3],k,k2]](* //. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *) /. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
k2++;];
k++;];
];
i3++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];

Init3ScalarFunctionsFinal[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,listP},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init3ScalarFunctionsFinal\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 3 external scalars and optionally a gauge structure. Only field combinations giving a tree-level coupling are considered.";
SA`Doc`Input={"list1in"->"List of functions with three external scalars","list1inNE"->"List of functions with three external scalars (where the results should not be expanded","list2in"->"List of functions with three external scalars and a gauge index","list4in"->"List of functions with three external scalars and a gauge index as well as an external vector boson","list3in"->"List of functions with three external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];

(* listP=Intersection[Table[getBlank/@lA3one[[i,1]],{i,1,Length[lA3one]}]]; *)
listP=Intersection[getBlank/@lA3oneNewFlat];

For[i1=1,i1<=Length[listP],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3]]=ExpandTermNS[list1b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3]]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0};
il++;];
For[il=1,il<=Length[list1NE],list1NE[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3]]=(list1NE[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3]]);
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],k]=(ExpandTermNS[list2b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],k]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
For[il=1,il<=Length[list4b],list4b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],k,vecB_]=(ExpandTermNS[list4b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],k,vecB]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
For[k2=1,k2<=Length[Gauge],For[il=1,il<=Length[list3b],list3b[[il,1]][getFullNS[listP[[i1,1]]]/.subGCRule[1],getFullNS[listP[[i1,2]]]/.subGCRule[2],getFullNS[listP[[i1,3]]]/.subGCRule[3],k,k2]=(ExpandTermNS[list3b[[il,2]][getFullNS[listP[[i1,1]]]/.subGC[1],getFullNS[listP[[i1,2]]]/.subGC[2],getFullNS[listP[[i1,3]]]/.subGC[3],k,k2]](*//.sum[a_,b_,c_] d_\[RuleDelayed]Sum[d,{a,b,c}]*)/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
il++;];
k2++;];
k++;];
i1++;];

SA`Doc`EndEntry[];
]; 

Init3ScalarFunctionsPermutated[list1in_,list1inNE_,list2in_,list3in_,list4in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list2b,list3b,list4b,list1NE,i,per},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init3ScalarFunctionsPermutated\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 3 external scalars and optionally a gauge structure. Only field combinations giving a tree-level coupling are considered.";
SA`Doc`Input={"list1in"->"List of functions with three external scalars","list1inNE"->"List of functions with three external scalars (where the results should not be expanded","list2in"->"List of functions with three external scalars and a gauge index","list4in"->"List of functions with three external scalars and a gauge index as well as an external vector boson","list3in"->"List of functions with three external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1NE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list4b=Table[{list4in[[i]],ToExpression[ToString[list4in[[i]]]<>"func"]},{i,1,Length[list4in]}];
per=Intersection[Flatten[Permutations/@Intersection[Sort/@lA3oneNewFlat],1]];

For[i1=1,i1<=Length[per],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3]]=CalcDelta[(ExpandTermNS[list1b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3] ]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
For[il=1,il<=Length[list1NE],
list1NE[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3]]=(list1NE[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3] ]);
il++;];

For[k=1,k<=Length[Gauge],
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[per[[i1,1]]]/. subGCRule[1],getFullNS[per[[i1,2]]]/. subGCRule[2],getFullNS[per[[i1,3]]]/. subGCRule[3],k, k2]=CalcDelta[(ExpandTermNS[list3b[[il,2]][getFullNS[per[[i1,1]]]/. subGC[1],getFullNS[per[[i1,2]]]/. subGC[2],getFullNS[per[[i1,3]]]/. subGC[3],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0})];
il++;];
k2++;];
k++;];

i1++;];

SA`Doc`EndEntry[];
];

Init1ScalarFunctions[list1in_,list1inNE_,list2in_,list2Gin_,list3in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list1bNE,list2b,list3b,list2G},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init1ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 1 external scalar and optionally a gauge structure.";
SA`Doc`Input={"list1in"->"List of functions with one external scalar","list1inNE"->"List of functions with one external scalar (where the results should not be expanded","list2in"->"List of functions with one external scalar and a gauge index","list4in"->"List of functions with three one scalar and a gauge index as well as an external vector boson","list3in"->"List of functions with one external scalar and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1bNE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list2G=Table[{list2Gin[[i]],ToExpression[ToString[list2Gin[[i]]]<>"func"]},{i,1,Length[list2Gin]}];
For[i1=1,i1<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1]]=ExpandTermNS[list1b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1]]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[il=1,il<=Length[list1bNE],
list1bNE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1]]=list1bNE[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1]];
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],k]=ExpandTermNS[list2b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],k ]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],k, vecB_]=ExpandTermNS[list3[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],k,vecB]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list2G],
list2G[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],k, k2]=ExpandTermNS[list2G[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],k,k2]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
k2++;];
k++;];
i1++;];

SA`Doc`EndEntry[];
];

SA`sub2Scalar={};

Init2ScalarFunctions[list1in_,list1inNE_,list2in_,list2Gin_,list3in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list1bNE,list2b,list3b,list2G},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external scalars and optionally a gauge structure. ";
SA`Doc`Input={"list1in"->"List of functions with 2 external scalars","list1inNE"->"List of functions with 2 external scalars (where the results should not be expanded","list2in"->"List of functions with 2 external scalars and a gauge index","list3in"->"List of functions with 2 external scalars and a gauge index as well as an external vector boson","list2Gin"->"List of functions with 2 external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1bNE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list2G=Table[{list2Gin[[i]],ToExpression[ToString[list2Gin[[i]]]<>"func"]},{i,1,Length[list2Gin]}];
For[i1=1,i1<=Length[PART[S]],
For[i2=1,i2<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2]]=(ExpandTermNS[list1b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2]]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0} );
il++;];
For[il=1,il<=Length[list1bNE],
list1bNE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2]]=(list1bNE[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2]]);
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k]=(ExpandTermNS[list2b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k ]]//.  sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0});
il++;];
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, vecB_]=(ExpandTermNS[list3[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k,vecB]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0});
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list2G],
If[SA`Casimir[PART[S][[i1]],k]=!=0 && SA`Casimir[PART[S][[i2]],k]=!=0 && SA`Casimir[PART[S][[i1]],k]2=!=0 && SA`Casimir[PART[S][[i2]],k2]=!=0, 
list2G[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, k2]=(ExpandTermNS[list2G[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0} );,
list2G[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, k2]=0;
];
il++;];
k2++;];
k++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];

Init2ScalarFunctionsSymm[list1in_,list1inNE_,list2in_,list2Gin_,list3in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list1bNE,list2b,list3b,list2G},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2ScalarFunctionsSymm\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external scalars and optionally a gauge structure. ";
SA`Doc`Input={"list1in"->"List of functions with 2 external scalars","list1inNE"->"List of functions with 2 external scalars (where the results should not be expanded","list2in"->"List of functions with 2 external scalars and a gauge index","list3in"->"List of functions with 2 external scalars and a gauge index as well as an external vector boson","list2Gin"->"List of functions with 2 external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1bNE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list2G=Table[{list2Gin[[i]],ToExpression[ToString[list2Gin[[i]]]<>"func"]},{i,1,Length[list2Gin]}];
For[i1=1,i1<=Length[PART[S]],
For[i2=i1,i2<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2]]=(ExpandTermNS[list1b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2]]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0} );
il++;];
For[il=1,il<=Length[list1bNE],
list1bNE[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2]]=(list1bNE[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2]]);
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k]=(ExpandTermNS[list2b[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k ]]//.  sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0});
il++;];
For[il=1,il<=Length[list3b],
list3b[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, vecB_]=(ExpandTermNS[list3[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k,vecB]]//. sum[a_,b_,c_] d_ :>Sum[d,{a,b,c}] /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0});
il++;];
For[k2=1,k2<=Length[Gauge],
For[il=1,il<=Length[list2G],
(* If[SA`Casimir[PART[S][[i1]],k]=!=0 && SA`Casimir[PART[S][[i2]],k]=!=0 && SA`Casimir[PART[S][[i1]],k]2=!=0 && SA`Casimir[PART[S][[i2]],k2]=!=0, *)
list2G[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, k2]=(ExpandTermNS[list2G[[il,2]][getFullNS[PART[S][[i1]]]/. subGC[1],getFullNS[PART[S][[i2]]]/. subGC[2],k,k2]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0} );(*,
list2G[[il,1]][getFullNS[PART[S][[i1]]]/. subGCRule[1],getFullNS[PART[S][[i2]]]/. subGCRule[2],k, k2]=0;
];*)
il++;];
k2++;];
k++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];

Init2ScalarFunctionsFinal[list1in_,list1inNE_,list2in_,list2Gin_,list3in_]:=Block[{i1,i2,i3,i4,il,k,k2,list1b,list1bNE,list2b,list3b,list2G,listP},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2ScalarFunctionsFinal\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external scalars and optionally a gauge structure. ";
SA`Doc`Input={"list1in"->"List of functions with 2 external scalars","list1inNE"->"List of functions with 2 external scalars (where the results should not be expanded","list2in"->"List of functions with 2 external scalars and a gauge index","list3in"->"List of functions with 2 external scalars and a gauge index as well as an external vector boson","list2Gin"->"List of functions with 2 external scalars and two gauge indices"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list1bNE=Table[{list1inNE[[i]],ToExpression[ToString[list1inNE[[i]]]<>"func"]},{i,1,Length[list1inNE]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
list2G=Table[{list2Gin[[i]],ToExpression[ToString[list2Gin[[i]]]<>"func"]},{i,1,Length[list2Gin]}];

listP=Sort/@Intersection[lA2oneNewFlat];
For[i1=1,i1<=Length[listP],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[listP[[i1,1]]]/. subGCRule[1],getFullNS[listP[[i1,2]]]/. subGCRule[2]]=(ExpandTermNS[list1b[[il,2]][getFullNS[listP[[i1,1]]]/. subGC[1],getFullNS[listP[[i1,2]]]/. subGC[2]]]/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0} );
il++;];
i1++;];

SA`Doc`EndEntry[];
];

Init2FermionFunctions[list1in_,list2in_,list3in_]:=Block[{i1,i2,i3,i4,il,k,list1b,list2b,list3b},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2FermionFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external fermions and optionally a gauge structure. ";
SA`Doc`Input={"list1in"->"List of functions with 2 fermions","list2in"->"List of functions with 2 external fermions and a gauge index","list3in"->"List of functions with 2 external fermions and a gauge index as well as an external vector boson"};

SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
list2b=Table[{list2in[[i]],ToExpression[ToString[list2in[[i]]]<>"func"]},{i,1,Length[list2in]}];
list3b=Table[{list3in[[i]],ToExpression[ToString[list3in[[i]]]<>"func"]},{i,1,Length[list3in]}];
For[i1=1,i1<=Length[PARTALL[F]],
For[i2=1,i2<=Length[PARTALL[F]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2]]=ExpandTermNS[list1b[[il,2]][getFullNS[PARTALL[F][[i1]]]/. subGC[1],getFullNS[PARTALL[F][[i2]]]/. subGC[2]]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*) /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[k=1,k<=Length[Gauge],
For[il=1,il<=Length[list2b],
list2b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2],k]=ExpandTermNS[list2b[[il,2]][getFullNS[PARTALL[F][[i1]]]/. subGC[1],getFullNS[PARTALL[F][[i2]]]/. subGC[2],k ]](*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*) /. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
For[il=1,il<=Length[list3b],
list3b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2],k, vecB_]=ExpandTermNS[list3b[[il,2]][getFullNS[PARTALL[F][[i1]]]/. subGC[1],getFullNS[PARTALL[F][[i2]]]/. subGC[2],k,vecB]] (*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*)/. {Yijk[a__]->0,Aijk[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0};
il++;];
k++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];

Init2Fermion1ScalarFunctions[list1in_]:=Block[{i1,i2,i3,i4,il,k,list1b,list2b,list3b},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2Fermion1ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external fermions and one scalar. ";
SA`Doc`Input={"list1in"->"List of functions with 2 fermions and one scalar"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
For[i1=1,i1<=Length[PARTALL[F]],
For[i2=1,i2<=Length[PARTALL[F]],
For[i3=1,i3<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2],PART[S][[i3]]/. subGCRule[3]]=CalcDelta[ExpandTermNS[list1b[[il,2]][PARTALL[F][[i1]]/. subGC[1],PARTALL[F][[i2]]/. subGC[2],PART[S][[i3]]/. subGC[3]]]/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0}(*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*) ];
il++;];
i3++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];
Init2Fermion2ScalarFunctions[list1in_]:=Block[{i1,i2,i3,i4,il,k,list1b,list2b,list3b},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2Fermion2ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external fermions and two scalars. ";
SA`Doc`Input={"list1in"->"List of functions with 2 fermions and two scalars"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
For[i1=1,i1<=Length[PARTALL[F]],
For[i2=1,i2<=Length[PARTALL[F]],
For[i3=1,i3<=Length[PART[S]],
For[i4=1,i4<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2],PART[S][[i3]]/. subGCRule[3],PART[S][[i4]]/. subGCRule[4]]=CalcDelta[ExpandTermNS[list1b[[il,2]][PARTALL[F][[i1]]/. subGC[1],PARTALL[F][[i2]]/. subGC[2],PART[S][[i3]]/. subGC[3],PART[S][[i4]]/. subGC[4]]]/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0}(*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*)];
il++;];
i4++;];
i3++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];
Init2Fermion3ScalarFunctions[list1in_]:=Block[{i1,i2,i3,i4,i5,i6,il,k,list1b,list2b,list3b,per},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2Fermion3ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external fermions and 3 scalars. ";
SA`Doc`Input={"list1in"->"List of functions with 2 fermions and 3 scalars"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];
(*  per=Intersection[Flatten[Permutations[#,{3}]&/@Intersection[Sort/@Table[getBlank[lA4[[i,1]]],{i,1,Length[lA4]}]],1]]; *)
per=Intersection[Permutations[(getBlank/@Flatten[{PART[S],PART[S],PART[S]}]),{3}]];
For[i3=1,i3<=Length[per],
For[i1=1,i1<=Length[PARTALL[F]],
For[i2=1,i2<=Length[PARTALL[F]],
For[il=1,il<=Length[list1b],
 list1b[[il,1]][PARTALL[F][[i1]]/. subGCRule[1],PARTALL[F][[i2]]/. subGCRule[2],getFullNS[per[[i3,1]]]/. subGCRule[3],getFullNS[per[[i3,2]]]/. subGCRule[4],getFullNS[per[[i3,3]]]/. subGCRule[5]]=CalcDelta[ExpandTermNS[list1b[[il,2]][PARTALL[F][[i1]]/. subGC[1],PARTALL[F][[i2]]/. subGC[2],getFullNS[per[[i3,1]]]/.subGC[3],getFullNS[per[[i3,2]]]/.subGC[4],getFullNS[per[[i3,3]]]/. subGC[5]]]/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0}(*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}]*) ]; 
il++;];
i2++;];
i1++;];
 i3++;]; 

SA`Doc`EndEntry[];
];

Init2Fermion4ScalarFunctions[list1in_]:=Block[{i1,i2,i3,i4,i5,i6,il,k,list1b,list2b,list3b},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"Init2Fermion4ScalarFunctions\",\nInitializationCell->True]\)";
SA`Doc`Info = "This routine calculates the invariants with 2 external fermions and 4 scalars. ";
SA`Doc`Input={"list1in"->"List of functions with 2 fermions and 4 scalars"};
SA`Doc`GenerateEntry[];

list1b=Table[{list1in[[i]],ToExpression[ToString[list1in[[i]]]<>"func"]},{i,1,Length[list1in]}];

For[i1=1,i1<=Length[PARTALL[F]],
For[i2=i1,i2<=Length[PARTALL[F]],
For[i3=1,i3<=Length[PART[S]],
For[i4=1,i4<=Length[PART[S]],
For[i5=1,i5<=Length[PART[S]],
For[i6=1,i6<=Length[PART[S]],
For[il=1,il<=Length[list1b],
list1b[[il,1]][getFullNS[PARTALL[F][[i1]]]/. subGCRule[1],getFullNS[PARTALL[F][[i2]]]/. subGCRule[2],getFullNS[PART[S][[i3]]]/. subGCRule[3],getFullNS[PART[S][[i4]]]/. subGCRule[4],getFullNS[PART[S][[i5]]]/. subGCRule[5],getFullNS[PART[S][[i6]]]/. subGCRule[6]]=CalcDelta[ExpandTermNS[list1b[[il,2]][PARTALL[F][[i1]]/. subGC[1],PARTALL[F][[i2]]/. subGC[2],PART[S][[i3]]/. subGC[3],PART[S][[i4]]/. subGC[4],PART[S][[i5]]/. subGC[5],PART[S][[i6]]/. subGC[6]]]/. {Yijk[a__]->0,Aijk[a__]->0,m2ij[a__]->0, Muij[a__]->0, Bij[a__]->0, LSi->0 /. Li->0}(*//. sum[a_,b_,c_] d_ \[RuleDelayed]Sum[d,{a,b,c}] *)];
il++;];
i6++;];
i5++;];
i4++;];
i3++;];
i2++;];
i1++;];

SA`Doc`EndEntry[];
];


InitializeInvariants[TwoLoop_]:=Block[{i,j,k,k2, i1,i2,i3,i4,temp},
SA`Doc`File = "Package/RGEs/nonSUSYrges_aux.nb";
SA`Doc`Name = "\!\(\*
StyleBox[\"InitializeInvariants\",\nInitializationCell->True]\)";
SA`Doc`Info = "Wrapper function to pre-calculate all the invariants. First, everything is put to zero what can't exist. Afterwards, the functions to calculate the invariants are called with the list of suitable functions. If possible, the results are symmetrized with respect to the external fields.";
SA`Doc`Input={"TwoLoop"->"Include two-loop invariants?"};
SA`Doc`GenerateEntry[];

(* What has to be zero for sure ... *)
For[i=1,i<=Length[PARTALL[F]],
Lam2[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
Habcd[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
LamY[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
LamS[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
LamABCD[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
Aabcd[a___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],b___]=0;
YcM[a_,b_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
cYM[a_,b_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
McY[a_,b_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
McM[a_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
cMM[a_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
McM[getFullNS[PARTALL[F][[i]]]/. subGCRule[1],a_]=0;
cMM[getFullNS[PARTALL[F][[i]]]/. subGCRule[1],a_]=0;
cMY[a_,b_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1]]=0;
YcY[a_,b_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
cYY[a_,b_,c_,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
YcYY[a_,b_,c___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
cYYcY[a_,b_,c___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
YcYYcY[a_,b_,c___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
cYYcYY[a_,b_,c___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
Y2S[c___,getFullNS[PARTALL[F][[i]]]/. subGCRule[1],d___]=0;
i++];

For[i=1,i<=Length[PART[S]],
YcY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
YcY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
YcYY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
YcYY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYYcY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYYcY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
YcYYcY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
YcYYcY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYYcYY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
cYYcYY[getFullNS[PART[S][[i]]]/. subGCRule[1],b___]=0;
McM[a_,getFullNS[PART[S][[i]]]/. subGCRule[1]]=0;
McM[getFullNS[PART[S][[i]]]/. subGCRule[1],b_]=0;
cMM[a_,getFullNS[PART[S][[i]]]/. subGCRule[1]]=0;
cMM[getFullNS[PART[S][[i]]]/. subGCRule[1],b_]=0;
YcM[getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
YcM[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
cYM[getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
cYM[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
McY[getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
McY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
cMY[getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
cMY[a_,getFullNS[PART[S][[i]]]/. subGCRule[1],d___]=0;
i++;];

(* If[MemorySaveMode=!=True, *)
Print[StyleForm["Fermion bilinear","Section",FontSize->12]];
listInit={Y2F,Y2FC,McM,cMM};
listInitGauge={}; listInitGaugeAux={};
Init2FermionFunctions[listInit,listInitGauge,listInitGaugeAux];
Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];
(* fermion chains *)
Print[StyleForm["Fermion chains","Section",FontSize->12]];
(* PrintAll["     ... 1-loop"]; *)
Init2Fermion1ScalarFunctions[{YcM,cYM,McY,cMY}];
Init2Fermion2ScalarFunctions[{YcY,YcY2S}];
(* Init2Fermion2ScalarFunctions[{cYY}]; *)
Init2Fermion3ScalarFunctions[{YcYY}];
(*  YcYY[f1_,f2_,a_,b_,c_]:=YcYY[f2,f1,c,b,a]/;OrderedQ[{f1,f2}]\[Equal]False;  *)
(* Init2Fermion3ScalarFunctions[{cYYcY}]; *)

(*
If[TwoLoop\[Equal]True,
 Init2Fermion4ScalarFunctions[{YcYYcY}]; 
(* Init2Fermion4ScalarFunctions[{cYYcYY}]; *)
YcYYcY[f1_,f2_,a_,b_,c_,d_]:=Conj[YcYYcY[f2,f1,d,c,b,a]]/;OrderedQ[{f1,f2}]\[Equal]False;
];
*)

cYYcYY[a__]:=Conj[YcYYcY[a]];
cYYcY[a__]:=Conj[YcYY[a]];
cYY[a__]:=Conj[YcY[a]];
cYY2S[a__]:=Conj[YcY2S[a]];
Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];


(* scalar bilinears *)
Print[StyleForm["Scalar bilinear","Section",FontSize->12]];
PrintAll["     ... 1-loop"];
listInit={Y2S,Lam2S,LamY};
listInitGauge={Y2FS};listInitNotExpaned={LamS};
Init2ScalarFunctions[listInit,listInitNotExpaned,listInitGauge,{},{}];
listInit={Y2S,Lam2S,LamY};
Init2ScalarFunctionsSymm[{H2ab,Hbar2,Hab},{},{},{},{}];

Y2S[a_,b_]:=Y2S@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Lam2S[a_,b_]:=Lam2S@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
H2ab[a_,b_]:=H2ab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Hbar2[a_,b_]:=Hbar2@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Hab[a_,b_]:=Hab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamY[a_,b_]:=LamY@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamS[a_,b_]:=LamS@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Y2FS[a_,b_,f_]:=Y2FS@@Join[SortBy[{a,b},getBlank[#]&],{f}]/;OrderedQ[getBlank/@{a,b}]==False;
(* Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"]; *)

If[TwoLoop==True,
PrintAll["     ... 2-loop"];
listInit={LamBar3,LamBar2Y,Alam,AlamBar};
listInitNotExpaned={LamSC2G,LamSS};
Init2ScalarFunctionsSymm[listInit,listInitNotExpaned,{},{},{}];

listInit={HbarLam,HYab,HY, HYbar,H3ab};
Init2ScalarFunctionsFinal[listInit,{},{},{},{}];

LamBar3[a_,b_]:=LamBar3@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamBar2Y[a_,b_]:=LamBar2Y@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HbarLam[a_,b_]:=HbarLam@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HYab[a_,b_]:=HYab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HY[a_,b_]:=HY@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HYbar[a_,b_]:=HYbar@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
H3ab[a_,b_]:=H3ab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Alam[a_,b_]:=Alam@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
AlamBar[a_,b_]:=AlamBar@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamSC2G[a_,b_]:=LamSC2G@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamSS[a_,b_]:=LamSS@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;


Init2ScalarFunctionsSymm[{},{},{},{ThTh,TaTaYY1,TaTaYY2,TaTaYY3},{}];
(* ThTh[a_,b_,f_,g_]:=ThTh@@Join[Sort[{a,b}],{f,g}]/;OrderedQ[{a,b}]\[Equal]False; *)
ThTh[a_,b_,f_,g_]:=ThTh@@Join[SortBy[{a,b},getBlank[#]&],{f,g}]/;OrderedQ[getBlank/@{a,b}]==False;
TaTaYY1[a_,b_,f_,g_]:=TaTaYY1@@Join[SortBy[{a,b},getBlank[#]&],{f,g}]/;OrderedQ[getBlank/@{a,b}]==False;
TaTaYY2[a_,b_,f_,g_]:=TaTaYY2@@Join[SortBy[{a,b},getBlank[#]&],{f,g}]/;OrderedQ[getBlank/@{a,b}]==False;
TaTaYY3[a_,b_,f_,g_]:=TaTaYY3@@Join[SortBy[{a,b},getBlank[#]&],{f,g}]/;OrderedQ[getBlank/@{a,b}]==False;


listInit={BY,BYbar,LamBar2S,Lam2g,HFab};
listInitNotExpaned={HSab};
Init2ScalarFunctions[listInit,listInitNotExpaned,{},{},{}];
BY[a_,b_]:=BY@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
BYbar[a_,b_]:=BYbar@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
LamBar2S[a_,b_]:=LamBar2S@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Lam2g[a_,b_]:=Lam2g@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HFab[a_,b_]:=HFab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
HSab[a_,b_]:=HSab@@SortBy[{a,b},getBlank[#]&]/;OrderedQ[getBlank/@{a,b}]==False;
Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];
];

If[SkipScalarRGEs=!=True,
(* -------- scalar quartic --------- *)
Print[StyleForm["Scalar quartic","Section",FontSize->12]];
Print["     ... 1-loop"];
(* first,  some functions needed for the others *)

Init4ScalarFunctionsPermutatedAll[{YcYYcY4},{},{},{},{}];
cYYcYY4[a__]:=Conj[YcYYcY4[a]];


listInitGaugeAux={LamABCD}; 
Init4ScalarFunctions[{},{},{},{},listInitGaugeAux];
YC4abcd[a___]=Conj[Y4abcd[a]];

(*
For[i1=1,i1\[LessEqual]Length[PART[S]],
For[i2=i1,i2\[LessEqual]Length[PART[S]],
For[i3=i2,i3\[LessEqual]Length[PART[S]],
For[i4=1,i4\[LessEqual]Length[PART[S]],
LamY2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i2]]]/.subGCRule[2],getFullNS[PART[S][[i3]]]/.subGCRule[3],getFullNS[PART[S][[i4]]]/.subGCRule[4]]=(ExpandTermNS[LamY2func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i2]]]/.subGC[2],getFullNS[PART[S][[i3]]]/.subGC[3],getFullNS[PART[S][[i4]]]/.subGC[4]]]/.{Yijk[a__]\[Rule]0,Aijk[a__]\[Rule]0,Muij[a__]\[Rule]0,Bij[a__]\[Rule]0,LSi\[Rule]0/.Li\[Rule]0});
i4++;];
i3++;];
i2++;];
i1++;];
LamY2[a_,b_,c_,d_]:=LamY2[b,a,c,d] /;OrderedQ[{a,b}]\[Equal]False;
LamY2[a_,b_,c_,d_]:=LamY2[a,c,b,d] /;OrderedQ[{b,c}]\[Equal]False;
*)

For[i1=1,i1<=Length[PART[S]],
For[i2=i1,i2<=Length[PART[S]],
For[k=1,k<=Length[Gauge],
For[k2=k,k2<=Length[Gauge],
If[SA`Casimir[PART[S][[i1]],k]=!=0 && SA`Casimir[PART[S][[i2]],k]=!=0 && SA`Casimir[PART[S][[i1]],k]2=!=0 && SA`Casimir[PART[S][[i2]],k2]=!=0, 
LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq1func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq2func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});

LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq1func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq2func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});

LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq1func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq2func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});

LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq1func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=(ExpandTermNS[LamABCDsq2func[getFullNS[PART[S][[i1]]]/.subGC[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGC[2],getFullNS[PART[S][[i2]]]/.subGC[3],getFullNS[PART[S][[i2]]]/.subGC[4],k,k2]]/.{Yijk[a__]->0,Aijk[a__]->0,Muij[a__]->0,Bij[a__]->0,LSi->0/.Li->0});,



LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=0;
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=0;

LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=0;
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=0;
LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=0;
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]/.subExchangeScalarRI]/.subGCRule[4],k,k2]=0;
LamABCDsq1[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=0;
LamABCDsq2[getFullNS[PART[S][[i1]]]/.subGCRule[1],getFullNS[PART[S][[i1]]/.subExchangeScalarRI]/.subGCRule[2],getFullNS[PART[S][[i2]]]/.subGCRule[3],getFullNS[PART[S][[i2]]]/.subGCRule[4],k,k2]=0;
];
k2++;];
k++;];
i2++;];
i1++;];

LamABCDsq1[a_,b_,c_,d_,k1_,k2_]:=LamABCDsq1[c,d,a,b,k1,k2]/;OrderedQ[{getBlank/@{a,b},getBlank/@{c,d}}]==False;
LamABCDsq2[a_,b_,c_,d_,k1_,k2_]:=LamABCDsq2[c,d,a,b,k1,k2]/;OrderedQ[{getBlank/@{a,b},getBlank/@{c,d}}]==False;
LamABCDsq1[a_,b_,c_,d_,k1_,k2_]:=LamABCDsq1[a,b,c,d,k2,k1]/;(k1>k2);
LamABCDsq2[a_,b_,c_,d_,k1_,k2_]:=LamABCDsq2[a,b,c,d,k2,k1]/;(k1>k2);

LamABCDsq1[a_,b_,c_,d_,k1_,k2_]:=0/;(((getBlank[a]=!=getBlank[b])&& (getBlank[a]=!=(getBlank[b]/.subExchangeScalarRI)))||((getBlank[c]=!=getBlank[d])&&(getBlank[c]=!=(getBlank[d]/.subExchangeScalarRI))) );
LamABCDsq2[a_,b_,c_,d_,k1_,k2_]:=0/;(((getBlank[a]=!=getBlank[b])&& (getBlank[a]=!=(getBlank[b]/.subExchangeScalarRI)))||((getBlank[c]=!=getBlank[d])&&(getBlank[c]=!=(getBlank[d]/.subExchangeScalarRI))) );

Init4ScalarFunctions[{},{LamABCDsq1SUM,LamABCDsq2SUM},{},{},{}]; 
Init4ScalarFunctionsFinal[{Lam2,Habcd,LamY,LamS,LamBar3,AbarLabcd,ALabcd},{},{},{},{}];

];

(* Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"]; *)

(*  Now, two-loop functions *)
If[TwoLoop==True,
Print["     ... 2-loop"];
 Init4ScalarFunctions[{Y4abcd},{},{},{},{}]; 


Init4ScalarFunctionsPermutated[{Y24abcd,Y6abcd,(*YC6abcd,*)Y6abcd2},{},{},{},{}];
YC6abcd[a__]:=Conj[Y6abcd[a]];

Init4ScalarFunctionsSymm[{LamTT},{},{},{},{}];
LamTT[a_,b_,c_,d_]:=LamTT[b,a,c,d] /;OrderedQ[getBlank/@{a,b}]==False;
LamTT[a_,b_,c_,d_]:=LamTT[a,b,d,c] /;OrderedQ[getBlank/@{c,d}]==False;
LamTT[a_,b_,c_,d_]:=LamTT[c,d,a,b] /;OrderedQ[{getBlank/@{a,b},getBlank/@{c,d}}]==False;


listInitNotExpaned= {DSLLabcd,DFLLabcd,CGLLabcd,ThThTaTaYY1,ThThTaTaYY2};
Init4ScalarFunctions[{},listInitNotExpaned,{},{},{}];


Init4ScalarFunctions[{},{FFThThThTh},{},{},{}];

listInitNotExpaned={Lam2g,HSabcd,H3,HY,HbarY, AabcdDynkinS,AabcdDynkinF,AabcdC2G, LamSS,LamSC2G,LamSS2F,LamSS2S};
listInit={(*LamBar, *)LamBar2Y,HbarLam,HFabcd};
Init4ScalarFunctionsFinal[listInit,listInitNotExpaned,{},{},{}];

Init4ScalarFunctionsSymm[{LamBar2SAux},{},{},{},{}];

LamBar2SAux[a_,b_,c_,d_]:=LamBar2SAux[b,a,c,d] /;OrderedQ[getBlank/@{a,b}]==False;
LamBar2SAux[a_,b_,c_,d_]:=LamBar2SAux[a,b,d,c] /;OrderedQ[getBlank/@{c,d}]==False;
LamBar2SAux[a_,b_,c_,d_]:=LamBar2SAux[c,d,a,b] /;OrderedQ[{getBlank/@{a,b},getBlank/@{c,d}}]==False;
LamBar2Y[a_,b_,c_,d_]:=LamBar2Y[b,a,c,d] /;OrderedQ[getBlank/@{a,b}]==False;
LamBar2Y[a_,b_,c_,d_]:=LamBar2Y[a,b,d,c] /;OrderedQ[getBlank/@{c,d}]==False;
LamBar2Y[a_,b_,c_,d_]:=LamBar2Y[c,d,a,b] /;OrderedQ[{getBlank/@{a,b},getBlank/@{c,d}}]==False;


listInitNotExpaned={ BY, BYbar};
Init4ScalarFunctionsFinal[{},listInitNotExpaned,{},{},{}]; 

Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];
];

(* -------- cubic quartic --------- *)
Print[StyleForm["Scalar cubic","Section",FontSize->12]];
If[Length[SA`SSSlist]>0,
Print["     ... 1-loop"];
Init3ScalarFunctionsFinal[{Lam2,Habc,LamY,LamS},{},{},{},{}];
(* Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"]; *)
If[TwoLoop==True,
Print["     ... 2-loop"];
Init1ScalarFunctions[{},{},{},{TaTaYM1,TaTaYM2,TaTaYM3,TaTaYM4,TaTaYM5,TaTaYM6},{}];
Init3ScalarFunctionsPermutated[{LamBar2SAux},{},{},{},{}];
Init3ScalarFunctionsPermutated[{HFabcAux,LamTT,HbarLamMAux,HbarHAux,HYAux,HYbarAux,H3Aux},{},{},{},{}];
Init3ScalarFunctionsPermutated[{},{ThThTaTaYM1,ThThTaTaYM2},{},{},{}];
Init3ScalarFunctionsFinal[{AbarLabc,ALabc,BY,BYbar,HbarLamM,HbarH,HSabc,HY,HYbar,H3,Lam2g,HFabc,LamSS,LamSC2G, LamSS2F,LamSS2S,LamBar3,LamBar2Y},{},{},{},{}];
Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];
];,
Print["     ... 1-loop"];
Print["     ... 2-loop"];
Print["                      (Time needed so far: ",TimeUsed[]-TimeStartedRGEs,"s)"];
];
Print["All necessary invariants are ready (Time needed: ",TimeUsed[]-TimeStartedRGEs,"s)"];
Print[""];

SA`Doc`EndEntry[];
];
